<?php
// app/code/local/Envato/Custompaymentmethod/Model/Paymentmethod.php
class Teqpay_TeqpayPos_Model_Paymentmethod extends Mage_Payment_Model_Method_Abstract
{
    protected $_code = 'teqpaypos';
    protected $_formBlockType = 'teqpaypos/form_form';
    protected $_infoBlockType = 'teqpaypos/info_info';

    public function assignData($data)
    {
        Mage::getSingleton('core/session')->setData('teqpayParams', $_POST);
        return $this;
    }

    public function form()
    {
        $params = Mage::getSingleton('core/session')->getData('teqpayParams');
        $orderId = Mage::getSingleton('checkout/session')->getLastRealOrderId();
        $order = Mage::getSingleton('sales/order')->loadByIncrementId($orderId);
        $order->setPaymentMethod('teqpaypos');
        $order->save();
        $billingAddress = $order->getBillingAddress();
        $shippingAddress = $order->getShippingAddress();
        //echo $billingAddress->getFirstname();
        $api_key = Mage::getStoreConfig('payment/teqpaypos/apikey');
        $api_secret = Mage::getStoreConfig('payment/teqpaypos/apisecret');

        $count = 0;
        foreach ($order->getAllItems() as $item) {
            $count += (int) $item->getQtyOrdered();
        }
        // This is where the fun stuff begins
        $price = 0;
        /* Login for deduct discount amount */
        $dis_per_product_amount = 0;
        $dis_total_amount = 0;
        if ($order->getDiscountAmount() != 0) {
            $dis_total_amount = number_format(abs($order->getDiscountAmount()), 2, ".", "");
            $item_count = $count;
            $dis_per_product_amount = $dis_total_amount / $item_count;
        }
        $items = [];
        foreach ($order->getAllItems() as $item) {
            $items[] = [
				'merchantItemId' => $item->getId(),
				'itemType' => 'Ürün',
				'itemCategory' => 'Ürün',
                'itemName' => $item->getName(),
                'itemPrice' => ($item->getPrice() * (int) $item->getQtyOrdered() - $item->getDiscountAmount()) / (int) $item->getQtyOrdered(),
                'itemQuantity' => (int) $item->getQtyOrdered(),
            ];
        }

        if ($order->getShippingAmount() > 0) {
            $items[] = [
 				'merchantItemId' => "1000000000000",
				'itemType' => 'Kargo',
				'itemCategory' => 'Kargo',
                'itemName' => 'Kargo',
                'itemPrice' => $order->getShippingAmount(),
                'itemQuantity' => 1,
            ];
        }

		$billing_name = $billingAddress->getFirstname() . ' ' . $billingAddress->getLastname();
		$shipping_name = $shippingAddress->getFirstname() . ' ' . $shippingAddress->getLastname();

		$billing = [
			"billingName" => $billing_name,
            "billingCity" => $billingAddress->getCity() ?? 'Girilmedi',
            "billingCountry" => $billingAddress->getCountry() ?? 'Girilmedi',
            "billingAddress" => $billingAddress->getStreet()[1] ?? 'Girilmedi'
		];

		$shipping = [
			"shippingContactName" => $shipping_name,
            "shippingCity" => $shippingAddress->getCity() ?? 'Girilmedi',
            "shippingCountry" => $shippingAddress->getCountry() ?? 'Girilmedi',
            "shippingAddress" => $billingAddress->getStreet()[1] ?? 'Girilmedi'
		];

        $lang = explode(
            '_',
            Mage::app()
                ->getLocale()
                ->getLocaleCode()
        );

        $data = [

			// Customer
            'customerName' => $billing_name ?? '',
            'customerIpAddress' => $this->ip(),
            'customerCitizenNo' => 12345678901,
            'customerEmail' => $billingAddress->getEmail(),
            'customerPhone' => $billingAddress->getTelephone(),
            'language' => 'TR',
			// Order
            'price' => number_format(abs($order->getGrandTotal()), 2, ".", ""),
			'currency' => $order->getOrderCurrencyCode(),
			'conversationId' => $order->getIncrementId(),

			// Products
			'products' => $items,

			// Billign
			'billing' => $billing,

			// Shipping
			'shipping' => $shipping,

            'callbackUrl' => Mage::getBaseUrl() . 'teqpay/payment/response?order_id=' . $orderId,
            
        ];

        // Credit Card
        $card_data = [];
        if(isset($params['common']) && $params['common'] == '0')
        {
            $card_data['cardData'] = [
                "cardNo" => $params['payment']['cc_number'],
                "cardHolderName" => $params['payment']['_cc_owner'],
                "expDate" => $params['payment']['cc_exp_month'] . '/' . substr ($params['payment']['cc_exp_year'], -2),
                "cvv" => $params['payment']['cc_cid'], 
                "installment" => $params['payment']['installment'],
                "isPreAuth" => "false"
            ];

            $data['paymentMethodId'] = "1";
            $data['moneyTransferData'] = [
                'ibanNo' => null,
                'moneyTransferCode' => null

            ];
        }

		return array_merge($data, $card_data);
    }

    public function validate()
    {
        parent::validate();
        return $this;
    }

	private function ip()
	{
		$ip = '';
		if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
			$ip = $_SERVER['HTTP_CLIENT_IP'];
		} elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
			$ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
		} else {
			$ip = $_SERVER['REMOTE_ADDR'];
		}

		return $ip;
	}

    public function getOrderPlaceRedirectUrl()
    {
        return Mage::getUrl('teqpay/payment/redirect', ['_secure' => false]);
    }
}
